package cordova.plugin.chief.push;

import android.app.ActivityManager;
import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.os.Environment;
import android.os.Process;
import android.text.TextUtils;
import android.util.Log;

import com.huawei.android.pushagent.api.PushManager;
import com.xiaomi.mipush.sdk.MiPushClient;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import cn.jpush.android.api.JPushInterface;

/**
 * 作者：隔壁骆叔叔 on 2017/6/12.
 * 邮箱：android_luochen@163.com
 */
public class MobilePhoneType {
  //小米
  //public static final String APP_ID = "2882303761517584644";
  public static String app_key;
  public static String app_id;

  //public static final String APP_KEY = "5741758414644";
  //花为
  public static String HUATWEI_ALERT = "huawei_alert";
  public static String HUATWEI_EXTRAS = "huawei_extras";

  public static String ALERT = "alert";
  public static String EXTRAS = "extras";

  private static String TAG = "MobilePhoneType";
  public static final String SYS_EMUI = "sys_emui";    //华为
  public static final String SYS_MIUI = "sys_miui";    //小米
  public static final String SYS_JiGUANG = "sys_jiguang"; //极光

  private static PushInit mPushInit;

  public MobilePhoneType() {

  }


  private static final String KEY_MIUI_VERSION_CODE = "ro.miui.ui.version.code";
  private static final String KEY_MIUI_VERSION_NAME = "ro.miui.ui.version.name";
  private static final String KEY_MIUI_INTERNAL_STORAGE = "ro.miui.internal.storage";
  private static final String KEY_EMUI_API_LEVEL = "ro.build.hw_emui_api_level";
  private static final String KEY_EMUI_VERSION = "ro.build.version.emui";
  private static final String KEY_EMUI_CONFIG_HW_SYS_VERSION = "ro.confg.hw_systemversion";

  public static String getSystem() {
    String SYS = null;
    try {
      Properties prop = new Properties();
      prop.load(new FileInputStream(new File(Environment.getRootDirectory(), "build.prop")));
      if (prop.getProperty(KEY_MIUI_VERSION_CODE, null) != null
        || prop.getProperty(KEY_MIUI_VERSION_NAME, null) != null
        || prop.getProperty(KEY_MIUI_INTERNAL_STORAGE, null) != null) {
        SYS = SYS_MIUI; //小米
      } else if (prop.getProperty(KEY_EMUI_API_LEVEL, null) != null
        || prop.getProperty(KEY_EMUI_VERSION, null) != null
        || prop.getProperty(KEY_EMUI_CONFIG_HW_SYS_VERSION, null) != null) {
        SYS = SYS_EMUI; //华为
      } else {
        SYS = SYS_JiGUANG;
      }
    } catch (IOException e) {
      e.printStackTrace();
      return SYS;
    }
    return SYS;
  }

  public static void getXiaoMiKey(Context context) {
    String current = getCurProcessName(context);
    String mainProcessName = context.getPackageName();
    if (!mainProcessName.equals(current)) {
      Log.e(TAG, "Init. Current process : " + current);
    } else {
      Log.e(TAG, "init : " + current);
      if (TextUtils.isEmpty(SingletonHolder.sRongIM.app_key) || TextUtils.isEmpty(SingletonHolder.sRongIM.app_id)) {
        try {
          ApplicationInfo applicationInfo = context.getPackageManager().getApplicationInfo(context.getPackageName(), PackageManager.GET_META_DATA);
          if (applicationInfo != null) {
            SingletonHolder.sRongIM.app_key = applicationInfo.metaData.getString("xiaomi_appkey").substring(1, applicationInfo.metaData.getString("xiaomi_appkey").length());

            Log.e("app_key", app_key);
            SingletonHolder.sRongIM.app_id = applicationInfo.metaData.getString("xiaomi_appid").substring(1, applicationInfo.metaData.getString("xiaomi_appid").length());
            Log.e("app_id", app_id);
          }
          if (TextUtils.isEmpty(SingletonHolder.sRongIM.app_key) || TextUtils.isEmpty(SingletonHolder.sRongIM.app_id)) {
            throw new IllegalArgumentException("can't find com.xiaomi.appkey in AndroidManifest.xml.");
          }
        } catch (PackageManager.NameNotFoundException var4) {
          var4.printStackTrace();
          throw new ExceptionInInitializerError("can't find packageName!");
        }
      }
    }
  }

  public static String getCurProcessName(Context context) {
    int pid = Process.myPid();
    ActivityManager mActivityManager = (ActivityManager) context.getSystemService("activity");
    List<ActivityManager.RunningAppProcessInfo> runningAppProcessInfos = mActivityManager.getRunningAppProcesses();
    if (runningAppProcessInfos == null) {
      return null;
    } else {
      Iterator var4 = runningAppProcessInfos.iterator();

      ActivityManager.RunningAppProcessInfo appProcess;
      do {
        if (!var4.hasNext()) {
          return null;
        }

        appProcess = (ActivityManager.RunningAppProcessInfo) var4.next();
      } while (appProcess.pid != pid);

      return appProcess.processName;
    }
  }

  public static void initRegister(Context context) {

    String type = MobilePhoneType.getSystem();
    SpData spData = new SpData(context);
    spData.setStringValue("sys_type", type);

      /*Toast.makeText(context,"小米注册："+type,Toast.LENGTH_SHORT).show();
      MiPushClient.registerPush(context, APP_ID, APP_KEY); */

    if (type != null) {
      if (type.equals("sys_emui")) {
        PushManager.requestToken(context);

        /* 测试延迟 才能发送成功 ionic还未初始化成功
          String alert=spData.getStringValue(HUATWEI_ALERT,null);
          String extras=spData.getStringValue(HUATWEI_EXTRAS,null);
          if (alert !=null && extras !=null){
            mPushInit = new PushInit();
            try {
              JSONObject jsonExtras = new JSONObject(extras);
              final JSONObject json = test(alert,jsonExtras);
              spData.setStringValue(HUATWEI_ALERT,null);
              spData.setStringValue(HUATWEI_EXTRAS,null);

              new Thread(new Runnable() {
                @Override
                public void run() {

                  try {
                    Thread.sleep(3000);
                    mPushInit.openNotificationReceive(json);
                  } catch (InterruptedException e) {
                    e.printStackTrace();
                  }
                }
              }).start();

            }catch (JSONException e){

            }
          }*/
      } else if (type.equals("sys_miui")) {
        MiPushClient.registerPush(context, app_id, app_key);
        /*  if (XiaoMiMessageReceiver.miJsonObject != null){
            mPushInit = new PushInit();
            mPushInit.openNotificationReceive(XiaoMiMessageReceiver.miJsonObject);
          }else {

          }*/
      } else {
        //Toast.makeText(context,"其他手机："+type,Toast.LENGTH_SHORT).show();
        JPushInterface.setDebugMode(true);
        JPushInterface.init(context);
      }
    } else {
      // Toast.makeText(context,"未检测出手机类型",Toast.LENGTH_SHORT).show();
      JPushInterface.setDebugMode(true);
      JPushInterface.init(context);
    }
  }


  public static String getType(Context context) {

    SpData spData = null;
    if (spData == null) {
      spData = new SpData(context);
    }
    return spData.getStringValue("sys_type", null);
  }


  //XIAOMI这里是检测进程是否存在的方法

/*  private boolean shouldInit() {
    ActivityManager am = ((ActivityManager) getSystemService(Context.ACTIVITY_SERVICE));
    List<ActivityManager.RunningAppProcessInfo> processInfos = am.getRunningAppProcesses();
    String mainProcessName = getPackageName();
    int myPid = Process.myPid();
    for (ActivityManager.RunningAppProcessInfo info : processInfos) {
      if (info.pid == myPid && mainProcessName.equals(info.processName)) {
        return true;
      }
    }
    return false;'
  }


  try {
      jsonObject.put("alert",alert);
      if (extras !=null){
        JSONObject jo;
        String key;
        Iterator keys1 = jo.keys();
        while (keys1.hasNext()){
          key = keys1.next().toString();
          jExtras.put(key,jo.getString(key));
          Log.d(TAG,"---->jExtras:"+jExtras.toString());
        }
      }

    } catch (JSONException e) {
      e.printStackTrace();
    }
  }


  */


  /**
   * 华为数据需要再次处理转化为jsonobj对象
   */

  private static JSONObject jExtras;

  private static JSONObject test(String alert, JSONObject extras) {
    JSONObject jsonObject = new JSONObject();
    try {
      jsonObject.put(ALERT, alert);
      if (extras != null) {

        jExtras = new JSONObject();

        String key;
        Iterator keys1 = extras.keys();
        while (keys1.hasNext()) {
          key = keys1.next().toString();
          jExtras.put(key, extras.getString(key));
        }
        jsonObject.put(EXTRAS, jExtras);
      } else {
        jsonObject.put(EXTRAS, null);
      }
    } catch (JSONException e) {
      e.printStackTrace();
    }

    return jsonObject;

  }

  static class SingletonHolder {
    static MobilePhoneType sRongIM = new MobilePhoneType();

    SingletonHolder() {
    }
  }


}
