package cordova.plugin.chief.push.pushclass;

import android.app.ActivityManager;
import android.app.NotificationManager;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.util.Log;
import android.widget.Toast;

import com.huawei.android.pushagent.api.PushEventReceiver;


import org.json.JSONException;
import org.json.JSONObject;

import java.io.UnsupportedEncodingException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import cordova.plugin.chief.push.PushInit;
import cordova.plugin.chief.push.PushProcessingClass;
import cordova.plugin.chief.push.SpData;

/**
 * 作者：隔壁骆叔叔 on 2017/6/29.
 * 邮箱：android_luochen@163.com
 */
public class HuaWeiReceiver extends PushEventReceiver {

  private Context mContext;
  private PushInit mPushInit;
  public static final String TAG = "HuaWeiReceiver";




  //获取注册后返回的ToKen
  @Override
  public void onToken(Context context, String token, Bundle bundle) {
    super.onToken(context, token, bundle);
    this.mContext = context;
    String belongId = bundle.getString("belongId");

    SpData spData = new SpData(context);
    spData.setStringValue("sys_huawei_regid",token);
    Log.d(TAG,"--------------------->"+spData);

  }

  @Override
  public void onPushMsg(Context context, byte[] bytes, String s) {
    super.onPushMsg(context, bytes, s);
  }

  //消息透传
  @Override
  public boolean onPushMsg(Context context, byte[] bytes, Bundle bundle) {
    String content = null;
    try {
      content = new String(bytes,"UTF-8");
    } catch (UnsupportedEncodingException e) {
      e.printStackTrace();
    }

    if (context != null){
      try {
        JSONObject jsonObject = new JSONObject(content);
        if (mPushInit == null){
          mPushInit = new PushInit();
        }
        mPushInit.messageTransmission(jsonObject);
      } catch (JSONException e) {
        e.printStackTrace();
      }
    }

    return false;
  }





  /**
   *
   * @param context
   * @param event     NOTIFICATION_OPENED:通知栏中的通知被点击打开  NOTIFICATION_CLICK_BTN:通知栏中通知上的按钮被点击
   * @param bundle
   */
  @Override
  public void onEvent(Context context, Event event, Bundle bundle) {
    super.onEvent(context, event, bundle);
    this.mContext = context;
    if (Event.NOTIFICATION_OPENED.equals(event) || Event.NOTIFICATION_CLICK_BTN.equals(event)) {
      Log.d(TAG, "------------->onEvent");

      int notifyId = bundle.getInt(BOUND_KEY.pushNotifyId, 0);
      if (0 != notifyId) {
        NotificationManager manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        manager.cancel(notifyId);
      }

      //解析数据返回JSONObject   String content = "收到通知附加消息： " + bundle.getString(BOUND_KEY.pushMsgKey);
    /*  JSONObject extrasObject = getBundle("context",bundle);
      if (mPushInit == null){
        mPushInit = new PushInit();
      }
      //注意 这里是打开通知没有其他操作
      mPushInit.openNotificationReceive(extrasObject);
      showPushMessage(RECEIVE_PUSH_MSG,"成双成对付付付付");*/


      JSONObject extrasObject = getBundle("context",bundle);
      if (mPushInit == null){
        mPushInit = new PushInit();
      }
      if (PushProcessingClass.isAppRunning(mContext)){

        mPushInit.openNotificationReceive(extrasObject);
      }else {
        //这里没起作用
      }
    }

    //标签上报 1 = LBS   2 = 标签
    else if (Event.PLUGINRSP.equals(event)){
      final int TYPE_LBS = 1;
      final int TYPE_TAG = 2;
      int reportType = bundle.getInt(BOUND_KEY.PLUGINREPORTTYPE, -1);             //获取返回类型
      boolean isSuccess = bundle.getBoolean(BOUND_KEY.PLUGINREPORTRESULT, false); //返回值
      String message = "";
      if (TYPE_LBS == reportType){
        message = "LBS report result :" + isSuccess;
      }else if (TYPE_TAG == reportType){
        message = "TAG report result :" + isSuccess;
      }
      Log.d(TAG,"标签 || 上报 -——》" + message);
    }
  }


  // 第一种 自己解析
  private JSONObject getBundle(String context,Bundle bundle){
    JSONObject data = new JSONObject();
    try {
      data.put("alert",context);
      JSONObject jExtras = new JSONObject();
      for (String keys : bundle.keySet()){
        Log.d(TAG,"---->keys:"+keys);
        if (keys.contains("pushMsg")){
          Object object = bundle.get("pushMsg");
          Log.d(TAG,"---->object:"+object);
          JSONObject jo;
          if (object != null){
            //  object = "{\"birthday\":\"1991-01-01\",\"sex\":\"男\",\"name\":\"鸿夫斯基\",\"age\":\"18\"}";
            object = object.toString().substring(1,object.toString().length() - 1);
            jo = new JSONObject((String) object);
            String key;
            Iterator keys1 = jo.keys();
            while (keys1.hasNext()){
              key = keys1.next().toString();
              jExtras.put(key,jo.getString(key));
              Log.d(TAG,"---->jExtras:"+jExtras.toString());
            }
          }
        }
      }
      data.put("extras",jExtras);
    } catch (JSONException e) {
      e.printStackTrace();
    }
    return data;
  }



  
}
