package cordova.plugin.chief.push.pushclass;

import android.content.Context;
import android.util.Log;
import android.widget.Toast;
import com.xiaomi.mipush.sdk.MiPushClient;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaInterface;
import org.json.JSONArray;
import java.util.Set;
import cn.jpush.android.api.JPushInterface;
import cn.jpush.android.api.TagAliasCallback;
import cordova.plugin.chief.push.MobilePhoneType;

/**
 * 作者：隔壁骆叔叔 on 2017/6/22.
 * 邮箱：android_luochen@163.com
 *
 * 别名
 *
 *  极光： alias 命名长度限制为 40 字节。（判断长度需采用UTF-8编码），是覆盖 非增量
 *  小米： 小米别名设置后无回掉 ，具体的看看API  做一下处理
 */
public class SetAliasClass {
  public static String TAG = "SetAliasClass";

  private Context context;
  private String phoneType;
  private JSONArray data;
  private CallbackContext callbackContext;



  public  void SetAliasClass(CordovaInterface context, String phoneType, JSONArray data, CallbackContext callbackContext){
    try {
      this.context = context.getActivity().getApplication();
      this.phoneType = phoneType;
      this.data = data;
      this.callbackContext = callbackContext;
      if (context != null){
        String alias = data.getString(0);
        mySetAlias(alias);
      }

    } catch (Exception e) {//JSON
      e.printStackTrace();
    }

  }

  public  void mySetAlias(String alias){
    if (alias == null){
	  Log.d(TAG,"null alias");
      return;
    }
    if (MobilePhoneType.SYS_EMUI.equals(phoneType)){
      Log.d(TAG,"华为："+phoneType);
      huawei(alias);
    }
    else if (MobilePhoneType.SYS_MIUI.equals(phoneType)){
      Log.d(TAG,"小米："+phoneType);
      xiaoMi(alias);
    }
    else if (MobilePhoneType.SYS_JiGUANG.equals(phoneType)){
      Log.d(TAG,"极光："+phoneType);
      jiGuang(alias);

    }else {
      Log.d(TAG,"Error reading tagAlias JSON");
      callbackContext.error("Error reading tagAlias JSON");
    }

  }


  //极光
  private void jiGuang(String alias){
    JPushInterface.setAlias(context, alias, new TagAliasCallback() {
      @Override
      public void gotResult(int i, String s, Set<String> set) {
        if (i == 0){

          callbackContext.success();
        }else {

          callbackContext.error("setAlias error");
        }
      }
    });
  }

  //小米
  private void xiaoMi(String alias){
    MiPushClient.setAlias(context,alias,null);
  }

  //华为
  private void huawei(String alias){
    Toast.makeText(context,"暂不支持华为别名设置："+alias,Toast.LENGTH_SHORT).show();
  }



}
