package cordova.plugin.chief.push.pushclass;

import android.content.Context;
import android.util.Log;
import com.huawei.android.pushagent.api.PushManager;
import com.xiaomi.mipush.sdk.MiPushClient;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaInterface;
import org.json.JSONArray;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import cn.jpush.android.api.JPushInterface;
import cn.jpush.android.api.TagAliasCallback;
import cordova.plugin.chief.push.MobilePhoneType;

/**
 * 作者：隔壁骆叔叔 on 2017/6/23.
 * 邮箱：android_luochen@163.com
 */
public class SetTagsClass {
  public static String TAG = "SetTagsClass";

  private Context context;
  private String phoneType;
  private JSONArray data;
  private CallbackContext callbackContext;



  public  void SetTagsClass(JSONArray data, CallbackContext callbackContext,String phoneType,CordovaInterface cordova){
    try {
      this.context = cordova.getActivity().getApplication();
      this.phoneType = phoneType;
      this.data = data;
      this.callbackContext = callbackContext;

      if (context != null){
        String alias = data.getString(0);
        MySetTags(alias);
      }

    } catch (Exception e) {//JSON
      e.printStackTrace();
    }

  }


  public  void MySetTags(String tags){
    if (tags == null){
      Log.d(TAG,"null tags");
      return;
    }

    if (MobilePhoneType.SYS_EMUI.equals(phoneType)){
      Log.d(TAG,"华为："+phoneType);
      huawei(tags);
    }
    else if (MobilePhoneType.SYS_MIUI.equals(phoneType)){
      Log.d(TAG,"小米："+phoneType);
      xiaoMi(tags);
    }
    else if (MobilePhoneType.SYS_JiGUANG.equals(phoneType)){
      Log.d(TAG,"极光："+phoneType);
      Set<String> jgTags = new HashSet<String>();
      jgTags.add(tags);
      jiGuang(jgTags);

    }else {
		Log.d(TAG,"Error reading tagAlias JSON");
      callbackContext.error("Error reading tagAlias JSON");
    }

  }




  //极光
  public void jiGuang(Set<String> tags){
    Log.d(TAG,"tags :"+tags);

    JPushInterface.setTags(context, tags, new TagAliasCallback() {
      @Override
      public void gotResult(int i, String s, Set<String> set) {
        if (i == 0){
          Log.d(TAG,"s :"+s);
          Log.d(TAG,"set :"+set.size());
          callbackContext.success();
        }else {
          callbackContext.error("setTags error");
           /*  new Thread() {
            @Override
            public void run() {
              super.run();
              try {
                jiGuang(tags);
                sleep(3000);
              } catch (InterruptedException e) {
                e.printStackTrace();
              }
            }
          }.start();*/
        }
      }
    });

  }









  //小米
  private void xiaoMi(String tags){
    MiPushClient.subscribe(context,tags,null);
  }


  //华为
  private void huawei(final String tags){
    //Toast.makeText(context,"暂不支持华为标签设置："+tags,Toast.LENGTH_SHORT).show();
    //新增
    String key = tags;
    String value = tags;
    HashMap<String ,String> map = new HashMap<String, String>();
    map.put(key,value);
    PushManager.setTags(context,map);
    //无回掉方法 建议延迟3秒后返回状态   执行查询方法判断是否设置成功
    new Thread() {
      @Override
      public void run() {
        try {
          Map<String,String> tagsMap;
          tagsMap = PushManager.getTags(context);
          if (tagsMap !=null && !tagsMap.isEmpty()){
            for (Map.Entry<String,String> mapEntry :tagsMap.entrySet()){
              String key = mapEntry.getKey();
              String value = mapEntry.getValue();
              if (key !=null && value !=null){
                callbackContext.success("success");
              }
            }
          }else {
            callbackContext.error("setTags error");
          }

          sleep(3000);
        } catch (Exception e) {
        }
      }
    }.start();

  }



}
