/** var exec = require('cordova/exec');

exports.coolMethod = function(arg0, success, error) {
    exec(success, error, "PushInit", "coolMethod", [arg0]);
}; **/

var PushInit = function() {}

PushInit.prototype.isPlatformIOS = function () {
  return (device.platform === 'iPhone' ||
    device.platform === 'iPad' ||
    device.platform === 'iPod touch' ||
    device.platform === 'iOS')
}

PushInit.prototype.receiveMessage = {}
PushInit.prototype.openNotification = {}
PushInit.prototype.receiveNotification = {}


//异常回调
PushInit.prototype.errorCallback = function(msg) {
    console.log('Javascript Callback Error: ' + msg)
}

//公用方法
PushInit.prototype.callNative = function(name, args, successCallback) {
    cordova.exec(successCallback, this.errorCallback, 'PushInit', name, args)
}

//常用方法  
//目前不考虑其他，只做android初始化
PushInit.prototype.init = function(successCallback) {
    if (this.isPlatformIOS()) {
        this.callNative('initial', [], successCallback)
    } else {
        this.callNative('init', [], successCallback)
    }
}
//设备id
PushInit.prototype.getUuid = function(successCallback) {
    this.callNative('getUuid', [], successCallback);
}

//设备id
PushInit.prototype.getHuaweiData = function(successCallback) {
    this.callNative('getHuaweiData', [], successCallback);
}

//设置别名
PushInit.prototype.setAlias = function(alias) {
    this.callNative('setAlias', [alias], null);
}
//设置标签
PushInit.prototype.setTags = function(tags) {
    this.callNative('setTags', [tags], null);
}

PushInit.prototype.setApplicationIconBadgeNumber = function (badge) {
  if (this.isPlatformIOS()) {
    this.callNative('setApplicationIconBadgeNumber', [badge], null)
  }
}

//获取通知  jpush.receiveNotification
PushInit.prototype.receiveNotificationInAndroidCallback = function(data) {
    data = JSON.stringify(data)
    console.log('PushInit:receiveNotificationInAndroidCallback: ' + data)
    this.receiveNotification = JSON.parse(data)
    cordova.fireDocumentEvent('jpush.receiveNotification', this.receiveNotification)
}

//打开通知
PushInit.prototype.openNotificationInAndroidCallback = function(data) {
    data = JSON.stringify(data)
    console.log('PushInit:openNotificationInAndroidCallback: ' + data)
    this.openNotification = JSON.parse(data)
    cordova.fireDocumentEvent('jpush.openNotification', this.openNotification)
}

//消息透传
PushInit.prototype.messageTransmissionInAndroidCallback = function(data) {
    data = JSON.stringify(data)
    console.log('PushInit:messageTransmissionInAndroidCallback: ' + data)
    this.receiveMessage = JSON.parse(data)
    cordova.fireDocumentEvent('jpush.receiveMessage', this.receiveMessage)
}

PushInit.prototype.getUserNotificationSettings = function (callback) {
  if (this.isPlatformIOS()) {
    this.callNative('getUserNotificationSettings', [], callback)
  } else if (device.platform == 'Android') {
    this.callNative('areNotificationEnabled', [], callback)
  }
}


PushInit.prototype.openSetingOfNotification = function(data) {
    this.callNative('openSetingOfNotification', [data], null)
}

if (!window.plugins) {
    window.plugins = {}
}

if (!window.plugins.pushInit) {
    window.plugins.pushInit = new PushInit()
}

module.exports = new PushInit()